<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignDirectMailList StructType
 * @subpackage Structs
 */
class CampaignDirectMailList extends AbstractStructBase
{
    /**
     * The campaignDirectMail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CampaignDirectMail[]
     */
    public $campaignDirectMail;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for CampaignDirectMailList
     * @uses CampaignDirectMailList::setCampaignDirectMail()
     * @uses CampaignDirectMailList::setReplaceAll()
     * @param \StructType\CampaignDirectMail[] $campaignDirectMail
     * @param bool $replaceAll
     */
    public function __construct(array $campaignDirectMail = array(), $replaceAll = true)
    {
        $this
            ->setCampaignDirectMail($campaignDirectMail)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get campaignDirectMail value
     * @return \StructType\CampaignDirectMail[]|null
     */
    public function getCampaignDirectMail()
    {
        return $this->campaignDirectMail;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignDirectMail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignDirectMail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignDirectMailForArrayConstraintsFromSetCampaignDirectMail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $campaignDirectMailListCampaignDirectMailItem) {
            // validation for constraint: itemType
            if (!$campaignDirectMailListCampaignDirectMailItem instanceof \StructType\CampaignDirectMail) {
                $invalidValues[] = is_object($campaignDirectMailListCampaignDirectMailItem) ? get_class($campaignDirectMailListCampaignDirectMailItem) : sprintf('%s(%s)', gettype($campaignDirectMailListCampaignDirectMailItem), var_export($campaignDirectMailListCampaignDirectMailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The campaignDirectMail property can only contain items of type \StructType\CampaignDirectMail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set campaignDirectMail value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignDirectMail[] $campaignDirectMail
     * @return \StructType\CampaignDirectMailList
     */
    public function setCampaignDirectMail(array $campaignDirectMail = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignDirectMailArrayErrorMessage = self::validateCampaignDirectMailForArrayConstraintsFromSetCampaignDirectMail($campaignDirectMail))) {
            throw new \InvalidArgumentException($campaignDirectMailArrayErrorMessage, __LINE__);
        }
        $this->campaignDirectMail = $campaignDirectMail;
        return $this;
    }
    /**
     * Add item to campaignDirectMail value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignDirectMail $item
     * @return \StructType\CampaignDirectMailList
     */
    public function addToCampaignDirectMail(\StructType\CampaignDirectMail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignDirectMail) {
            throw new \InvalidArgumentException(sprintf('The campaignDirectMail property can only contain items of type \StructType\CampaignDirectMail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->campaignDirectMail[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\CampaignDirectMailList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
